# Information that can help you make a better MR

Please delete this entire section from your MR, as there's no point including it!

## CI information
- a docker image is generated and pushed for each new git tag (unless it fails)
  * a docker image can be generated and pushed **manually** for the `master` branch and for commits having WIP or wip in their titles
    + since it's advised not to use non-release docker images (e.g., `:latest` or `:master`) in production, those manually generated docker images' purpose is for testing only
- a commit with a title matching `/(fix|Fix|update|Update|upgrade|Upgrade)/` will not trigger a "dev status" check
  * if you have a merge request open and the latest commit doesn't have one of those words in its title, it'll trigger the "dev status" check, which consists in asserting that `src/db-schema/versions.sql` contains the right "dev status" (`false` or "`true` but beta" in the `master` branch, `true` otherwise)
  * read `.gitlab-ci.yml` for more information
- in order to avoid too much useless computations, CI does not automatically run for every branch. If you do not open a merge request, CI jobs will require to be triggered manually
- the opam environment dependency is hard-coded in `Dockerfile`, don't forget to update it if need be
  * e.g., `FROM registry.gitlab.com/tezos/opam-repository:runtime-build-dependencies--1db0e28de40c6416ed75ee092f7a803fe326069d as build`
  * if you update this part, you probably need to update `opam-list` accordingly or new fresh builds outside of docker will fail!
- the octez dependency (implementation of tezos) is hardcoded in `tezos.Makefile`, don't forget to update it if need be
  * e.g., `git clone https://gitlab.com/tezos/tezos.git -b master --single-branch && cd tezos && git checkout cd21420d8f0d947370caff33f19863da941649cf`
- the opam packages required for tezos-indexer are hard-coded in `opam.Makefile`
  * e.g., `TEZOS_INDEXER_OPAM_DEPS := caqti.1.6.0 caqti-driver-postgresql caqti-dynload caqti-lwt cmdliner conf-postgresql.1 mpp.0.3.5 uucd`, don't forget to update it if need be


## Generated files or sections
- `.nl.gitlab-ci.yml` is generated from `.gitlab-ci.yml` when you run `make .nl.gitlab-ci.yml`: do not forget to run that command if you update `.gitlab-ci.yml`.
- The `--help` section of the README file is generated by running `make update-README-help`: do not forget to run that command if you update the CLI options.
  * Note that this requires you to have successfully compiled `tezos-indexer`, since it relies on running `tezos-indexer --help` to generate that part.

## Git pre-hook
- `make git-hook-precommit` overwrites your local `.git/hooks/pre-commit` file to use some hooks that help avoid forgetting updating things like `.nl.gitlab-ci.yml` and `README.md`'s `--help` section.
  * do not run that command if you do not want your `.git/hooks/pre-commit` file to be overwritten!
  * read `git.Makefile` if you need to know more about what `make git-hook-precommit` actually does.
